<? /*************************************************************************************************
Copyright (c) 2003, 2004 Nathan 'Random' Rini
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*************************************************************************************************/
 /*
  Database Protocol
 */

 //query list class
 class db_querys {
  var $querys = array();
  var $db; //db api

  function db_querys($DBNAME, $DBSERVERHOST, $DBUSERNAME, $DBPASSWORD){
   $this->db = new db(); //create and open db
   $this->db->open($DBNAME, $DBSERVERHOST, $DBUSERNAME, $DBPASSWORD);
  }

  //returns a query - stops all repeats
  function &query($sql, $force = FALSE){
   if($sql == "") return false;

   if(!$force) //dont double check when force is on
    foreach($this->querys as $obj)
     if($obj->db_sql == $sql) return $obj;

   $obj = new db_query($sql,$this->db, $this);
   return $this->querys[] = &$obj;
  }

  function cleanup(){
   $this->db->close();
  }

  //Grab next id for table
  function nextid($table, $index){
   //grab table's info
   $query = new db_cmd("SELECT", "sequence", "nextid", "`table` = '".$table."' AND `index` = '".$index."'", 1);

   //bad entry
   if(empty($query->data) || !$query->data[0]["nextid"] > 0){
    //grab last id
    $query = new db_cmd("SELECT", $table, $index, '', 1, $index . " DESC");

    //grab next id from table
    $nextid = $query->data[0][$index] + 1;

    //create table
    $this->query("INSERT INTO sequence (`table`,`index`,`nextid`) VALUES ('".$table."', '".$index."', '".$nextid."')", 1);

    return $nextid;
   }

   //increment id
   $nextid = $query->data[0]["nextid"] + 1;

   //grab table's info
   new db_cmd("UPDATE", "sequence", array("nextid" => $nextid), "`index` = '".$index."' AND `table` = '".$table."'", 1);

   //grab next id
   return $nextid;
  }
 }

 //query class for db querys extends query class
 class db_query extends query {
  var $db_data     = array(); //all data from query - raw
  var $db_sql      = array(); //sql query called
  var $db_querylst; //db query list that made this

  function db_query($sql, &$db, &$querylst){
   $this->db_querylst = &$querylst;
   parent::query($db, $sql); //call parent constructor
   $this->db_sql = $sql;
  }

  //cleanup
  function clear(){
   $this->error = $this->db_querylst->db->error();
   $this->cleared  = 1;
   $this->db_data  = '';
   //$this->db_sql   = '';
  }

  //grab all data from query
  function load(){
   //check that there is a query to use
   if(!$this->result){$this->clear(); return;}
   if(!empty($this->db_data)) return; //dont reload if already loaded

   //override for 0 is filled
   $this->db_data[0] = $this->getrow();

   if($this->getrow()){//make sure next one loads up
    //grab all the remaining rows
    do if(!empty($this->row)) $this->db_data[] = $this->row;
    while($this->getrow());
   }

   $this->free(); //clear resources
  }
 }

 class db_cmd {
  var $query;
  var $data;

  function db_cmd($type, $table, $items = '', $where = '', $limit = '', $order = '', $force = FALSE){
   global $querys;

   switch(strtoupper($type)){
    case "SELECT":
     //make sure it always grabs the correct insert id
     if($items == "LAST_INSERT_ID()") $force = true;

     $sql = "SELECT "
      .($items==''?'*':(is_array($items)?implode(", ", $items):$items))
      .($table==''?'':" FROM ".$table)
      .($where==''?'':" WHERE ".$where)
      .($order==''?'':" ORDER BY ".$order)
      .($limit==''?'':" LIMIT ".$limit);

      $load = 1;
     break;
    case "UPDATE":
     if(is_array($items)){
      foreach($items as $key => $val)
       if($key != ''){
        if(gettype($key) != 'integer') $itemlst .= ($itemlst!=''?", ":'') . $key . "=\"" . convertsqlquotes($val) . "\"";
        else $itemlst .= ($itemlst!=''?", ":'') . $val;
       }
     }else $itemlst = &$items;

     $sql = "UPDATE "
      .$table
      ." SET ".$itemlst
      .($where==''?'':" WHERE ".$where)
      .($limit==''?'':" LIMIT ".$limit);
     break;
    case "INSERT":
     if(is_array($items)){
      foreach($items as $key => $val)
       if($key != ''){
        if(gettype($key) != 'integer') $itemlst .= ($itemlst!=''?", ":'') . "`".$key."`" . "=\"" . convertsqlquotes($val) . "\"";
        else $itemlst .= ($itemlst!=''?", ":'') . $val;
       }
     }else $itemlst = $items;

     $sql = "INSERT INTO ".$table." SET ".$itemlst;
     $force = TRUE;
     break;
    case "DELETE":
     $sql = "DELETE FROM ".$table.($where==''?'':" WHERE ".$where);
     break;
    case "DROP":
     $sql = "DROP TABLE IF EXISTS ".$table;
     break;
    case "SHOW":
     $sql = "SHOW ".$items.($table==''?'':" FROM ".$table);
     $load = 1;
     break;
   }
   //echo "<font color='#00FF00'>". $sql . "</font><br>";

   if($sql == '') return;

   $this->query = &$querys->query($sql, $force);
   if($load) $this->query->load();
   $this->data = &$this->query->db_data;
  }
 }

 //converts text for sql can save it
 function convertsqlquotes($val){
  return str_replace("\"","\\\"", str_replace("\\\"","\"", str_replace("'","\\'", str_replace("\\'","'",$val))));
 }

?>